package com.tutego.exercise.time;

import java.time.LocalDate;
import java.time.Month;
import java.time.Year;
import java.time.format.DateTimeFormatter;
import java.time.format.FormatStyle;
import java.util.Locale;

public class DateTimeFormatterDemo {
  public static void main( String[] args ) {
    //tag::solution[]
    LocalDate date = LocalDate.of( Year.now().getValue(), Month.SEPTEMBER, 19 );
    System.out.println( date );

    DateTimeFormatter formatterShort =
        DateTimeFormatter.ofLocalizedDate( FormatStyle.SHORT );
    DateTimeFormatter formatterMedium =
        DateTimeFormatter.ofLocalizedDate( FormatStyle.MEDIUM );
    DateTimeFormatter formatterLong =
        DateTimeFormatter.ofLocalizedDate( FormatStyle.LONG );
    DateTimeFormatter formatterFull =
        DateTimeFormatter.ofLocalizedDate( FormatStyle.FULL );

    DateTimeFormatter[] dateTimeFormatter = {
        formatterShort,
        formatterMedium,
        formatterLong,
        formatterFull,
        formatterShort.withLocale( Locale.CANADA_FRENCH ),
        formatterMedium.withLocale( Locale.CHINESE ),
        formatterLong.withLocale( Locale.ITALIAN ),
        formatterFull.withLocale( new Locale( "th" ) )
    };

    for ( DateTimeFormatter formatter : dateTimeFormatter )
      System.out.println( date.format( formatter ) );
    //end::solution[]
  }
}
